<template>
  <VForm
    name="post-update-form"
    :fields="fields"
    :modelState="modelState"
    buttonText="Update"
    buttonIconClass="bi bi-save-fill"
    :busy="updating"
    busyButtonText="Updating..."
    @submit="onSubmit"
  />
</template>

<script>
import { ref } from 'vue'
import { useRouter } from 'vue-router'
import { VForm, useApi, useNotification } from '../../core'
import { useAuth } from '../../identity'
import PostsApi from '../api/posts-api.js'

export default {
  name: 'PostCreateForm',
  components: {
    VForm,
  },
  props: {
    post: { type: Object, required: true },
  },
  setup(props) {
    const router = useRouter()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const postsApi = new PostsApi(api, auth)

    const modelState = ref({})
    const updating = ref(false)
    const fields = ref([
      {
        type: 'markdown',
        name: 'content',
        placeholder: 'Content',
        validate: 'required',
        value: props.post.content,
      },
    ])

    const onSubmit = async (form) => {
      updating.value = true

      let response
      try {
        response = await postsApi.updateAsync(props.post.id, form)
      } catch (ex) {
        if (ex.response.data?.modelState) {
          modelState.value = ex.response.data.modelState
        } else {
          notify.error('There was a problem updating your post.', ex)
        }
      } finally {
        updating.value = false
      }

      notify.success('Post updated successfully.')
      const alias = props.post.topic.alias
      const postId = response.data.id
      router.push({
        name: 'forum-topic',
        params: { alias, postId },
        hash: `#post${postId}`,
      })
    }

    return {
      modelState,
      updating,
      fields,
      onSubmit,
    }
  },
}
</script>
